//----------------------------------------------------------------------------------------
// les.H: Contains declarations for linear system solver
//----------------------------------------------------------------------------------------

#ifndef LES_SOLVER_H
#define LES_SOLVER_H

#include "general.H"

// Diagonal peconditioner for linear system solver
// Parameters: n - dimension of the system; a - system matrix; f - right hand side
inline
void diag_preconditioner(int n, long_real a[], real f[]);

// LU decomposition for linear system solver
// Parameters: n - dimension of the system; a - system matrix;
int LU_decomposition(int n, long_real a[]);

// LU substitution for linear system solver
// Parameters: n - dimension of the system; a - system matrix; u - right hand side/solution
void LU_substitution(int n, const long_real a[], real u[]);

#endif
